/* Buffer.h */
/* Copyright (C) 1995 Eric Young (eay@mincom.oz.au).
 * All rights reserved.
 * Copyright remains Eric Young's, and as such any Copyright notices in
 * the code are not to be removed.
 * See the COPYRIGHT file in the SSLeay distribution for more details.
 */

#ifndef HEADER_BUFFER_H
#define HEADER_BUFFER_H

typedef struct Buffer_st
	{
	int length;
	char *data;
	} BUFFER;

#ifdef PROTO
void	buffer_clean_up(void);
BUFFER *buffer_new(void);
void	buffer_free(BUFFER *a);
int	buffer_grow(BUFFER *str, long len);
int	buffer_get_tos(void);
void	buffer_set_tos(int a);
BUFFER *buffer_get_buf(void);
#else
void	buffer_clean_up();
BUFFER *buffer_new();
void	buffer_free();
int	buffer_grow();
int	buffer_get_tos();
void	buffer_set_tos();
BUFFER *buffer_get_buf();
#endif

#endif
